﻿using DataEntity;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PropertyChanged;
using System.Windows.Data;

namespace Sklad.ViewModels
{
    [AddINotifyPropertyChangedInterface]
    public class pgPrehMatVM : BaseVM
    {
        public pgPrehMatVM ()
        {
            var view = (CollectionView)CollectionViewSource.GetDefaultView(MaterialyCol);
            view.Filter = UserFilter;
        }

        private bool UserFilter (object item)
        {
            var it = (Material)item;

            return it.NazevMat.IndexOf(FiltrMaterialNazev, StringComparison.OrdinalIgnoreCase) >= 0;
        }

        private string _filtrMaterialNazev = "";

        public string FiltrMaterialNazev
        {
            get
            {
                return _filtrMaterialNazev;
            }
            set
            {
                _filtrMaterialNazev = value;
                CollectionViewSource.GetDefaultView(MaterialyCol).Refresh();
            }
        }


        private ObservableCollection<Material> materialyCol;

        public ObservableCollection<Material> MaterialyCol
        {
            get
            {
                if (materialyCol==null)
                {
                    materialyCol = new ObservableCollection<Material>
                        (Globals._context.Materialy);
                }
                return materialyCol;
            }
        }




        public Material MaterialSelected { get; set; }

        //public bool JeOznacenMaterial
        //{
        //    get
        //    {
        //        return MaterialSelected != null;
        //    }
        //}

        public bool JeOznacenMaterial => MaterialSelected != null;


        public enum Rezimy { Prohlizeni, Pridavani, Editace }

        private Rezimy _aktualniRezim = Rezimy.Prohlizeni;
        public Rezimy AktualniRezim
        {
            get
            {
                return _aktualniRezim;
            }
            set
            {
                _aktualniRezim = value;
                //následující řádka - příprava na to, aby nebylo možno používat menu při editaci
                //Globals._parentvm.LzePouzivatMenu = _aktualniRezim == Rezimy.Prohlizeni; 
            }


        }

        public string AktualniRezimString
        {
            get
            {
                switch (AktualniRezim)
                {
                    case Rezimy.Pridavani: return "Přidávání";
                    case Rezimy.Editace: return "Editace";
                }
                return "Prohlížení";
            }
        }


        public bool RezimPridavaniNeboEditace
        {
            get
            {
                return AktualniRezim != Rezimy.Prohlizeni;
            }
        }



    }
}
